# we need 2 helper mappings, from letters to ints and the inverse
L2I = dict(zip("ABCDEFGHIJKLMNOPQRSTUVWXYZ",range(26)))
I2L = dict(zip(range(26),"ABCDEFGHIJKLMNOPQRSTUVWXYZ"))

key = 3
#plaintext = "DEFEND THE EAST WALL OF THE CASTLE"

# encipher
ciphertext = "149 168 225 185 178 161 109 134 228 187 170 231 174 183 234 185 164 233 182 178 227 192 99 219 188 181 149 192 178 225 195 172 227 180 99 233 181 168 149 148 164 226 175 172 233 109 166 221 174 175 225 178 177 220 178 113 149 157 175 218 174 182 218 109 182 218 187 167 149 198 178 234 191 99 232 188 175 234 193 172 228 187 99 214 187 167 149 144 153 149 193 178 149 182 166 214 187 166 228 177 168 181 180 164 226 175 172 233 191 168 232 178 164 231 176 171 163 176 178 226 109 180 234 188 183 222 187 170 149 191 168 219 178 181 218 187 166 218 135 99 172 133 115 217 178 120 166 129 169 219 123"
#for c in plaintext.upper():
#    if c.isalpha(): ciphertext += I2L[ (L2I[c] + key)%26 ]
#    else: ciphertext += c

# decipher
plaintext2 = "149 168 225 185 178 161 109 134 228 187 170 231 174 183 234 185 164 233 182 178 227 192 99 219 188 181 149 192 178 225 195 172 227 180 99 233 181 168 149 148 164 226 175 172 233 109 166 221 174 175 225 178 177 220 178 113 149 157 175 218 174 182 218 109 182 218 187 167 149 198 178 234 191 99 232 188 175 234 193 172 228 187 99 214 187 167 149 144 153 149 193 178 149 182 166 214 187 166 228 177 168 181 180 164 226 175 172 233 191 168 232 178 164 231 176 171 163 176 178 226 109 180 234 188 183 222 187 170 149 191 168 219 178 181 218 187 166 218 135 99 172 133 115 217 178 120 166 129 169 219 123"
for c in ciphertext.upper():
    if c.isalpha(): plaintext2 += I2L[ (L2I[c] - key)%26 ]
    else: plaintext2 += c

#print plaintext
print ciphertext
print plaintext2
